/*
 * Data.java
 *
 * Created on 21. květen 2006, 21:53
 *
 */

package cz.vse.xkucf03.slovnik;

import cz.vse.xkucf03.slovnik.db.*;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.util.Vector;

/**
 *
 * @author fiki
 */
public class Data {
    
    private Connection spojeni;
    private PreparedStatement sqlJazyk;
    private PreparedStatement sqlSlova;
    private PreparedStatement sqlSlovaOblibena;
    private PreparedStatement sqlSlovaVsechna;
    //private PreparedStatement sqlPrekladyP;
    private PreparedStatement sqlPrelozenaSlova;
    private PreparedStatement sqlUzivatel;
    private CallableStatement sqlUzivatelOverHeslo;
    private PreparedStatement sqlPridejOblibene;
    private PreparedStatement sqlOdeberOblibene;
    
    private PreparedStatement sqlInfoPocetSlov;
    private PreparedStatement sqlInfoPocetPrekladu;
    private PreparedStatement sqlInfoPocetUzivatelu;
    
    private PreparedStatement sqlSmazJazyk;
    private PreparedStatement sqlSmazKategorii;
    private PreparedStatement sqlSmazOblibene;
    private PreparedStatement sqlSmazPreklad;
    private PreparedStatement sqlSmazSlovniDruh;
    private PreparedStatement sqlSmazSlovo;
    private PreparedStatement sqlSmazUzivatele;
    
    private PreparedStatement sqlUlozJazyk;
    private PreparedStatement sqlUlozKategorii;
    private PreparedStatement sqlUlozOblibene;
    private PreparedStatement sqlUlozPreklad;
    private PreparedStatement sqlUlozSlovniDruh;
    private PreparedStatement sqlUlozSlovo;
    private PreparedStatement sqlUlozUzivatele;
    
    private PreparedStatement sqlVlozJazyk;
    private PreparedStatement sqlVlozKategorii;
    private PreparedStatement sqlVlozOblibene;
    private PreparedStatement sqlVlozPreklad;
    private PreparedStatement sqlVlozSlovniDruh;
    private PreparedStatement sqlVlozSlovo;
    private PreparedStatement sqlVlozUzivatele;
    
    
    public Data(String trida, String databaze, String jmeno, String heslo) throws SQLException, ClassNotFoundException {
        /** připojíme se */
        Class.forName(trida);
        spojeni = DriverManager.getConnection(databaze, jmeno, heslo);
        spojeni.setAutoCommit(true);
        
        
        
        /** připravíme dotazy */
        sqlJazyk = spojeni.prepareStatement("SELECT * FROM xkucf03.jazyk ORDER BY kod_jazyka");
        sqlSlova = spojeni.prepareStatement("SELECT * FROM xkucf03.slovo WHERE LOWER(slovo) LIKE LOWER(?) AND kod_jazyka = ?");
        sqlSlovaOblibena = spojeni.prepareStatement("SELECT slovo, kod_jazyka, kategorie, vyslovnost FROM xkucf03.oblibene JOIN xkucf03.slovo using(slovo, kod_jazyka) where login = ? ORDER BY slovo");
        sqlSlovaVsechna = spojeni.prepareStatement("SELECT * FROM xkucf03.slovo");
        //sqlPrekladyP = spojeni.prepareStatement("SELECT * FROM xkucf03.preklad p JOIN xkucf03.slovo zs ON(p.slovo_zdroj = zs.slovo  AND p.jazyk_zdroj = zs.kod_jazyka) JOIN xkucf03.slovo cs ON(p.slovo_cil = cs.slovo AND p.jazyk_cil = cs.kod_jazyka) JOIN xkucf03.jazyk zj ON(zs.kod_jazyka = zj.kod_jazyka) JOIN xkucf03.jazyk cj ON(cs.kod_jazyka = cj.kod_jazyka) JOIN xkucf03.slovni_druh sd ON (p.slovni_druh = sd.cislo_druhu) left join xkucf03.kategorie zk on (zs.kategorie = zk.zkratka) left join xkucf03.kategorie ck on (cs.kategorie = ck.zkratka) WHERE p.slovo_zdroj = ? and p.jazyk_zdroj = ? AND p.jazyk_cil = ?");
        sqlPrelozenaSlova = spojeni.prepareStatement("SELECT * FROM xkucf03.slovo WHERE slovo IN (SELECT slovo_cil FROM xkucf03.preklad WHERE slovo_zdroj = ? AND jazyk_zdroj = ? AND jazyk_cil = ?)");
        sqlUzivatel = spojeni.prepareStatement("SELECT * FROM xkucf03.uzivatel WHERE login = ? AND heslo = ?");
        sqlPridejOblibene = spojeni.prepareStatement("{call xkucf03.pridej_oblibene(?, ?, ?, ?)}");
        sqlOdeberOblibene = spojeni.prepareStatement("{call xkucf03.odeber_oblibene(?, ?, ?, ?)}");
        sqlUzivatelOverHeslo = spojeni.prepareCall("{call xkucf03.zkontroluj_heslo(?, ?, ?, ?)}");
        
        sqlInfoPocetSlov = spojeni.prepareStatement("SELECT count(*) as pocet FROM xkucf03.slovo");
        sqlInfoPocetPrekladu = spojeni.prepareStatement("SELECT count(*) as pocet FROM xkucf03.preklad");
        sqlInfoPocetUzivatelu = spojeni.prepareStatement("SELECT count(login) as pocet FROM xkucf03.uzivatel_bez_hesla");
        
        sqlSmazJazyk = spojeni.prepareStatement("DELETE FROM xkucf03.jazyk WHERE kod_jazyka = ?");
        sqlSmazKategorii = spojeni.prepareStatement("DELETE FROM xkucf03.kategorie WHERE zkratka = ?");
        sqlSmazOblibene = spojeni.prepareStatement("DELETE FROM xkucf03.oblibene WHERE login = ?, slovo = ? AND kod_jazyk = ?");
        sqlSmazPreklad = spojeni.prepareStatement("DELETE FROM xkucf03.preklad WHERE slovo_zdroj = ? AND slovo_cil = ? AND jazyk_zdroj = ? AND jazyk_cil = ? AND slovni_druh = ?");
        sqlSmazSlovniDruh = spojeni.prepareStatement("DELETE FROM xkucf03.slovni_druh WHERE cislo_druhu = ?");
        sqlSmazSlovo = spojeni.prepareStatement("DELETE FROM xkucf03.slovo WHERE slovo = ? AND kod_jazyka = ?");
        sqlSmazUzivatele = spojeni.prepareStatement("DELETE FROM xkucf03.uzivatel WHERE login = ?");
        
        sqlUlozJazyk = spojeni.prepareStatement("UPDATE xkucf03.jazyk SET kod_jazyka = ?, nazev_jazyka = ?, prislovce = ?, druhy_pad = ?  WHERE kod_jazyka = ?");
        sqlUlozKategorii = spojeni.prepareStatement("UPDATE xkucf03.kategorie SET zkratka = ?, nazev = ?, popis = ? WHERE zkratka = ?");
        sqlUlozOblibene = spojeni.prepareStatement("UPDATE xkucf03.oblibene SET login = ?, slovo = ?, kod_jazyka = ?  WHERE login = ?, slovo = ? AND kod_jazyk = ?");
        sqlUlozPreklad = spojeni.prepareStatement("UPDATE xkucf03.preklad SET slovo_zdroj = ? AND slovo_cil = ? AND jazyk_zdroj = ? AND jazyk_cil = ? AND slovni_druh = ? WHERE slovo_zdroj = ? AND slovo_cil = ? AND jazyk_zdroj = ? AND jazyk_cil = ? AND slovni_druh = ?");
        sqlUlozSlovniDruh = spojeni.prepareStatement("UPDATE xkucf03.slovni_druh SET cislo_druhu = ?, druh_cesky = ?, druh_latinsky = ? WHERE cislo_druhu = ?");
        sqlUlozSlovo = spojeni.prepareStatement("UPDATE xkucf03.slovo SET slovo = ?, kod_jazyka = ?, kategorie = ?, vyslovnost = ? WHERE slovo = ? AND kod_jazyka = ?");
        sqlUlozUzivatele = spojeni.prepareStatement("UPDATE xkucf03.uzivatel SET login = ?, heslo = ?, jmeno = ?, prijmeni = ? WHERE login = ?");
        
        sqlVlozJazyk = spojeni.prepareStatement("INSERT INTO xkucf03.jazyk VALUES (?,?,?,?)");
        sqlVlozKategorii = spojeni.prepareStatement("INSERT INTO xkucf03.kategorie VALUES (?,?,?)");
        sqlVlozOblibene = spojeni.prepareStatement("INSERT INTO xkucf03.oblibene VALUES (?,?,?)");
        sqlVlozPreklad = spojeni.prepareStatement("INSERT INTO xkucf03.preklad VALUES (?,?,?,?,?,?)");
        sqlVlozSlovniDruh = spojeni.prepareStatement("INSERT INTO xkucf03.slovni_druh VALUES (?,?,?)");
        sqlVlozSlovo = spojeni.prepareStatement("INSERT INTO xkucf03.slovo VALUES (?,?,?,?)");
        sqlVlozUzivatele = spojeni.prepareStatement("INSERT INTO xkucf03.uzivatel VALUES (?,?,?,?)");
    }
    
    public Vector <Jazyk> getJazyky() throws SQLException {
        Vector <Jazyk> v = new Vector <Jazyk>();
        ResultSet rs = sqlJazyk.executeQuery();
        
        
        while (rs.next()) {
            
            Jazyk j = new Jazyk(rs.getString("kod_jazyka"),
                    rs.getString("nazev_jazyka"),
                    rs.getString("prislovce"),
                    rs.getString("druhy_pad"));
            v.add(j);
        }
        
        return v;
    }
    
    public void odeberOblibene(Uzivatel u, Slovo s) throws SQLException {
        sqlOdeberOblibene.setString(1, u.login);
        sqlOdeberOblibene.setString(2, u.heslo);
        sqlOdeberOblibene.setString(3, s.slovo);
        sqlOdeberOblibene.setString(4, s.kodJazyka);
        
        sqlOdeberOblibene.execute();
    }
    
    public void pridejOblibene(Uzivatel u, Slovo s) throws SQLException {
        sqlPridejOblibene.setString(1, u.login);
        sqlPridejOblibene.setString(2, u.heslo);
        sqlPridejOblibene.setString(3, s.slovo);
        sqlPridejOblibene.setString(4, s.kodJazyka);
        
        sqlPridejOblibene.execute();
    }
    
    public Vector<Kategorie> getKategorie() {
        return null;
    }
    
    public Vector<Oblibene> getOblibene() {
        return null;
    }
    
    public Vector<Preklad> getPreklady() {
        return null;
    }
    
    public Vector<Slovo> getPrelozenaSlova(String slovo, String odkud, String kam) throws SQLException {
        Vector<Slovo> v = new Vector<Slovo>();
        
        sqlPrelozenaSlova.setString(1, slovo);
        sqlPrelozenaSlova.setString(2, odkud);
        sqlPrelozenaSlova.setString(3, kam);
        
        ResultSet rs = sqlPrelozenaSlova.executeQuery();
        
        
        
        while (rs.next()) {
            
            Slovo s = new Slovo(rs.getString("slovo"),
                    rs.getString("kod_jazyka"),
                    rs.getString("kategorie"),
                    rs.getString("vyslovnost"));
            v.add(s);
            
        }
        return v;
        
    }
    
    /** blbé ovladače Oraclu. Jako SQL to funguje, ale tady v JDBC to hlásí neplatný název sloupce * /
     * public Vector<PrekladP> getPrekladyP(String slovo, String odkud, String kam) throws SQLException {
     * Vector <PrekladP> v = new Vector <PrekladP>();
     *
     * System.out.println(slovo + odkud + kam);
     *
     * sqlPrekladyP.setString(1, slovo);
     * sqlPrekladyP.setString(2, odkud);
     * sqlPrekladyP.setString(3, kam);
     *
     * ResultSet rs = sqlPrekladyP.executeQuery();
     *
     * for (int i = 1; i <= rs.getMetaData().getColumnCount(); i++) {
     * System.out.println("Sloupec " + i + ": " + rs.getMetaData().getColumnName(i) + " - " + rs.getMetaData().getColumnType(i));
     * }
     *
     *
     * while (rs.next()) {
     *
     * Jazyk jazykZdroj = new Jazyk(rs.getString("p.jazyk_zdroj"), rs.getString("zj.nazev_jazyka"), rs.getString("zj.prislovce"), rs.getString("zj.druhy_pad"));
     * Jazyk jazykCil = new Jazyk(rs.getString("p.jazyk_cil"), rs.getString("cj.nazev_jazyka"), rs.getString("cj.prislovce"), rs.getString("cj.druhy_pad"));
     * SlovniDruh slovniDruh = new SlovniDruh(rs.getInt("p.slovni_druh"), rs.getString("sd.druh_cesky"), rs.getString("sd.druh_latinsky"));
     * Kategorie kategorieZdroj = new Kategorie(rs.getString("zk.zkratka"), rs.getString("zk.nazev"), rs.getString("zk.popis"));
     * Kategorie kategorieCil = new Kategorie(rs.getString("ck.zkratka"), rs.getString("ck.nazev"), rs.getString("ck.popis"));
     *
     * SlovoP slovoZdroj = new SlovoP(rs.getString("p.slovo_zdroj"), jazykZdroj, kategorieZdroj, rs.getString("zs.vyslovnost"));
     * SlovoP slovoCil = new SlovoP(rs.getString("p.slovo_cil"), jazykCil, kategorieCil, rs.getString("cs.vyslovnost"));
     *
     * PrekladP j = new PrekladP(slovoZdroj, slovoCil, slovniDruh, rs.getLong("p.priorita"));
     * v.add(j);
     * }
     *
     * return v;
     * }
     */
    
    public Vector<SlovniDruh> getSlovniDruhy() {
        return null;
    }
    
    public Vector<Slovo> getSlova() {
        return null;
    }
    
    public Vector<Slovo> getSlova(String castSlova, String jazyk) throws SQLException {
        Vector <Slovo> v = new Vector <Slovo>();
        sqlSlova.setString(1, "%" + castSlova + "%");
        sqlSlova.setString(2, jazyk);
        ResultSet rs = sqlSlova.executeQuery();
        
        
        while (rs.next()) {
            
            Slovo s = new Slovo(rs.getString("slovo"),
                    rs.getString("kod_jazyka"),
                    rs.getString("kategorie"),
                    rs.getString("vyslovnost"));
            v.add(s);
            
        }
        
        return v;
    }
    
    public Vector<Slovo> getSlovaOblibena(String login) throws SQLException {
        Vector <Slovo> v = new Vector <Slovo>();
        sqlSlovaOblibena.setString(1, login);
        ResultSet rs = sqlSlovaOblibena.executeQuery();
        
        
        while (rs.next()) {
            
            Slovo s = new Slovo(rs.getString("slovo"),
                    rs.getString("kod_jazyka"),
                    rs.getString("kategorie"),
                    rs.getString("vyslovnost"));
            v.add(s);
            
        }
        
        return v;
    }
    
    public Vector<Uzivatel> getUzivatele() {
        return null;
    }
    
    public Uzivatel getUzivatel(String login, String heslo) throws SQLException{
        sqlUzivatelOverHeslo.setString(1, login);
        sqlUzivatelOverHeslo.setString(2, heslo);
        sqlUzivatelOverHeslo.registerOutParameter(3, Types.VARCHAR);
        sqlUzivatelOverHeslo.registerOutParameter(4, Types.VARCHAR);
        
        sqlUzivatelOverHeslo.execute();
        
        Uzivatel u = new Uzivatel(login, heslo, sqlUzivatelOverHeslo.getString(3), sqlUzivatelOverHeslo.getString(4));
        return u;
        
    }
    
    public Vector<Informace> getInformace() throws SQLException {
        Vector<Informace> v = new Vector<Informace>();
        
        ResultSet rs;
        
        rs = sqlInfoPocetSlov.executeQuery();
        rs.next();
        v.add(new Informace("Počet slov", String.valueOf(rs.getLong(1))));
        
        rs = sqlInfoPocetPrekladu.executeQuery();
        rs.next();
        v.add(new Informace("Počet překladů", String.valueOf(rs.getLong(1))));
        
        rs = sqlInfoPocetUzivatelu.executeQuery();
        rs.next();
        v.add(new Informace("Počet uživatelů", String.valueOf(rs.getLong(1))));
        
        
        return v;
    }
    
    
    public void ulozJazyk(Jazyk j) throws SQLException {
        if (j.novy) {
            sqlVlozJazyk.setString(1, j.kodJazyka);
            sqlVlozJazyk.setString(2, j.nazevJazyka);
            sqlVlozJazyk.setString(3, j.prislovce);
            sqlVlozJazyk.setString(4, j.druhyPad);
            sqlVlozJazyk.executeUpdate();
        } else {
            sqlUlozJazyk.setString(1, j.kodJazyka);
            sqlUlozJazyk.setString(2, j.nazevJazyka);
            sqlUlozJazyk.setString(3, j.prislovce);
            sqlUlozJazyk.setString(4, j.druhyPad);
            sqlUlozJazyk.setString(5, j.kodJazyka);
            sqlUlozJazyk.executeUpdate();
        }
    }
    
    public void ulozKategorii(Kategorie k) {
        
    }
    
    public void ulozOblibene(Oblibene o) {
        
    }
    
    public void ulozPreklad(Preklad p) {
        
    }
    
    public void ulozSlovniDruh(SlovniDruh sD) {
        
    }
    
    public void ulozSlovo(Slovo s) {
        
    }
    
    public void ulozUzivatele(Uzivatel u) {
        
    }
    
    public void smazJazyk(Jazyk j) throws SQLException {
        sqlSmazJazyk.setString(1, j.kodJazyka);
        sqlSmazJazyk.executeUpdate();
    }
    
    public void smazKategorii(Kategorie k) {
        
    }
    
    public void smazOblibene(Oblibene o) {
        
    }
    
    public void smazPreklad(Preklad p) {
        
    }
    
    public void smazSlovniDruh(SlovniDruh sD) {
        
    }
    
    public void smazSlovo(Slovo s) {
        
    }
    
    public void smazUzivatele(Uzivatel u) {
        
    }
    
    
    public void zavriSpojeni() {
        try {
            spojeni.close();
            System.out.println("Spojení s DB ukončeno");
        } catch (SQLException ex) {
            System.out.println("CHYBA: spojení s DB se nepodařilo ukončit");
            ex.printStackTrace();
        }
    }
}
