/*
 * Slovnik.java
 *
 * Created on 21. květen 2006, 21:53
 *
 */

package cz.vse.xkucf03.slovnik;

import cz.vse.xkucf03.slovnik.admin.AdminGUI;
import cz.vse.xkucf03.slovnik.db.*;
import java.sql.SQLException;
import java.util.Properties;
import java.util.Vector;

/**
 * Prostředník mezi uživatelským rozhraním a třídou Data
 *
 * @author fiki
 */
public class Slovnik {
    
    private Data d;
    private Uzivatel u;
    private AdminGUI adminGUI;
    
    public Slovnik(String trida, String databaze, String jmeno, String heslo, String loginUzivatele, String hesloUzivatele) throws SQLException, ClassNotFoundException, ChybnyUzivatelException {
        d = new Data(trida, databaze, jmeno, heslo);
        u = d.getUzivatel(loginUzivatele, hesloUzivatele);
        if (u == null) {
            d.zavriSpojeni();
            throw new ChybnyUzivatelException("Neexistující uživatel aplikace nebo špatné heslo.");
        }
    }
    
    public Vector <Jazyk> getJazyky() throws SQLException {
        return d.getJazyky();
    }
    
    public Vector<Slovo> getSlova(String castSlova, String jazyk) throws SQLException {
        return d.getSlova(castSlova, jazyk);
    }
    
    public Vector<Slovo> getSlovaOblibena() throws SQLException {
        return d.getSlovaOblibena(u.login);
    }
    
    public void pridejOblibene(Slovo s) throws SQLException {
        d.pridejOblibene(u, s);
    }
    
    public void odeberOblibene(Slovo s) throws SQLException {
        d.odeberOblibene(u, s);
        
    }
    
    public void zavriSpojeni() {
        d.zavriSpojeni();
    }
    
    public String getInformace() {
        StringBuffer v = new StringBuffer();
        Vector<Informace> informace;
        
        try {
            informace = d.getInformace();
            v.append("<html>");
            v.append("<b>Uživatel: </b>" + u.login + "<br>");
            for (int i = 0; i < informace.size(); i++) {
                v.append("<b>" + informace.get(i).nazev + ":</b> " + informace.get(i).hodnota+ "<br>");
            }
            v.append("</html>");
        } catch (SQLException ex) {
            v.append("Chyba informací");
            ex.printStackTrace();
        }
        
        
        
        return v.toString();
    }
    
    /** TODO: přidat i možnost skrytí */
    public void setAdminGUIVisible(boolean v) {
        if (adminGUI == null) {
            adminGUI = new AdminGUI(d);
            adminGUI.setLocationRelativeTo(null);
        }
        
        adminGUI.setVisible(true);
        
    }
    
    public String getPrekladSlova(String slovo, String odkud, String kam) throws SQLException {
        StringBuffer v = new StringBuffer();
        
        Vector<Slovo> p = d.getPrelozenaSlova(slovo, odkud, kam);
        
        if (p.size() == 0) {
            return "Pro tento jazyk překlad slova není";
        }
        
        
        v.append("<html><ul>");
        
        for (int i = 0; i < p.size(); i++) {
            String vyslovnost = "";
            String kategorie = "";
            if (p.get(i).vyslovnost != null && p.get(i).vyslovnost != "") {
                vyslovnost = " [" + p.get(i).vyslovnost +  "] ";
            }
            
            if (p.get(i).kategorie != null && p.get(i).kategorie != "") {
                kategorie = " (<i>" + p.get(i).kategorie +  ".</i>) ";
            }
            
            v.append("<li>" + p.get(i).slovo + vyslovnost + kategorie + "</li>");
        }
        
        v.append("</ul></html>");
        
        return v.toString();
    }
}
